<?php
/************************************************************
*			Hyperspin RSS Parser version 1.1	*
*								*
*		    		 Code by Adam Neal		*
*					adam@amnwebtech.co.uk	*
*				Feedback and comments welcome	*
*								*
*	You may freely use and distribute the Source Code,	* 
*	with or without modification, but this Source Code is 	*
*	provided to you "AS IS" EXCLUSIVE OF ANY WARRANTY, 	*
*	INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OF 	*
*	MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE, OR *
*	ANY OTHER WARRANTY, WHETHER EXPRESS OR IMPLIED. IN NO 	*
*	EVENT WILL AMN Webtech HAVE ANY LIABILITY FOR ANY LOST 	*
*	PROFITS, LOSS OF DATA OR COSTS OF PROCUREMENT OF 	*
*	SUBSTITUTE GOODS OR SERVICES, OR FOR ANY SPECIAL, 	*
*	INDIRECT, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THIS 	*
*	AGREEMENT, INCLUDING, WITHOUT LIMITATION, THOSE 	*
*	RESULTING FROM THE USE OF THE SOURCE CODE, OR THE 	*
*	FAILURE OF THE SOURCE CODE TO PERFORM, OR FOR ANY OTHER *
*	REASON.							*
*								*
*	CHANGES:						*
*	1.0: Initial Relase					*
*	1.1: Changes to accomodate Average results now being	*
*	returned						*
************************************************************/

class hyperspinRSSParser
{	
	var $insideitem 				= false;
	var $tag 						= ""; 
	var $serverCount 				= 0;
	var $uptimeInfo 				= array();
	var $average					= false;
	var $averageIncluded				= false;
	
	var $totalCMOutages 			= 0;
	var $totalPMOutages 			= 0;
	var $totalOutages				= 0;
	var $totalCMDowntime			= 0;
	var $totalPMDowntime			= 0;
	var $totalDowntime				= 0;
	var $totalCMUptime				= 0;
	var	$totalPMUptime				= 0;
	var $totalUptime				= 0;

	var $averageSrvrUptime			= 0;
	var $averageSrvrDowntime		= 0;
	var $averageSrvrOutages			= 0;
	var $averageSrvrCMUptime		= 0;
	var $averageSrvrCMDowntime		= 0;
	var $averageSrvrCMOutages		= 0;
	var $averageSrvrPMUptime		= 0;
	var $averageSrvrPMDowntime		= 0;
	var	$averageSrvrPMOutages		= 0;

	var $URL;
	var $local;
	
	var $months						= array( 'Jan' => 1,
											 'Feb' => 2,
											 'Mar' => 3,
											 'Apr' => 4,
											 'May' => 5,
											 'Jun' => 6,
											 'Jul' => 7,
											 'Aug' => 8,
											 'Sep' => 9,
											 'Oct' => 10,
											 'Nov' => 11,
											 'Dec' => 12);
											 
	var $oldestDate					= 0;
	
	function hyperspinRSSParser($URL="http://www.hyperspin.com/publicreportrss2.0/30035/3502",$local=false)
	{
		$this->URL = $URL;
		$this->local = $local;
	}
	
	function setURL($URL)
	{
		$this->URL = $URL;
	}
	
	function parse()
	{
		$xml ="";
		print $local;
		if(!$this->local)
		{
			//use curl to pull back the XML
			$ch=curl_init();
			curl_setopt($ch, CURLOPT_URL, $this->URL);
			curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
			$xml = curl_exec ($ch);
			if(!$xml)
	                {
        	                die(curl_error($ch));
        	        }
        	        curl_close ($ch);
		}
		else
		{
			$handle = fopen($this->URL, "r");
			$xml = fread($handle, filesize($this->URL));
			fclose($handle);
		}
		
		
		//create the parser and setup the handlers
		$parser = xml_parser_create();
		
		xml_set_object($parser,&$this);
		xml_set_element_handler($parser, "tagOpen", "tagClose"); 
		xml_set_character_data_handler($parser, "characterData");
		xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
		
		//do all the work........
		xml_parse($parser,$xml);	
	}

	function tagOpen($parser, $name, $attrs) 
	{

		if ($this->insideitem) 
		{
			
			$this->tag = $name;
			
		} 
		elseif ($name == "ITEM") 
		{
		   $this->insideitem = true;
	   	} 
	}
	
	function tagClose($parser, $name) 
	{
		if($name == "ITEM")
		{

			$this->insideitem = false;
			$this->serverCount++;
		}
		$this->tag = "";
		//calculate the averages & format the date
		if($name == "RSS")
		{
			$servers = $this->serverCount;
			if($this->averageIncluded)
				$servers--;
			$this->averageSrvrCMUptime	= round($this->totalCMUptime/$servers,3);
			$this->averageSrvrPMUptime	= round($this->totalPMUptime/$servers,3);
			$this->averageSrvrUptime	= round($this->totalUptime/$servers,3);
			
			$this->averageSrvrCMDowntime= round($this->totalCMDowntime/$servers,2);
			$this->averageSrvrPMDowntime= round($this->totalPMDowntime/$servers,2);
			$this->averageSrvrDowntime	= round($this->totalDowntime/$servers,2);
			
			$this->averageSrvrCMOutages	= round($this->totalCMOutages/$servers,2);
			$this->averageSrvrPMOutages	= round($this->totalPMOutages/$servers,2);
			$this->averageSrvrOutages	= round($this->totalOutages/$servers,2);
			
			$this->oldestDate = date('M d Y',$this->oldestDate);
		}
		
	
	}
	
	function characterData($parser, $data) 
	{
		//set the flag for average
		if ($this->insideitem && $this->tag && strcmp($this->tag,"TITLE") == 0)
		{
			if(strcmp($data,"AVERAGE")==0)
			{
				$this->average = true;
				$this->averageIncluded = true;
			}
			else
				$this->average = false;
		}
	   	if ($this->insideitem && $this->tag && !(strpos($this->tag,"HYPERSPIN") === false))
		{
			switch($this->tag)
			{
				case "HYPERSPIN:TEST":
					$this->uptimeInfo[$this->serverCount]["name"] = $data;
					break;
				case "HYPERSPIN:STATUS":
					$this->uptimeInfo[$this->serverCount]["status"] = $data;
					break;
				case "HYPERSPIN:LASTUPD":
					$this->uptimeInfo[$this->serverCount]["last_update"] = $data;
					break;
				case "HYPERSPIN:NEXTUPD":
					$this->uptimeInfo[$this->serverCount]["next_update"] = $data;
					break;
				case "HYPERSPIN:UPDINTERVAL":
					$this->uptimeInfo[$this->serverCount]["update_interval"] = $data;
					break;
				case "HYPERSPIN:CURMONUPTIME":
					$this->uptimeInfo[$this->serverCount]["cm_uptime"] = floatval($data);
					if(!$this->average)
						$this->totalCMUptime += floatval($data);
					break;
				case "HYPERSPIN:CURMONDOWNTIME":
					if(strpos($data," ") > -1)
                                        {
                                                $hours = intval($data);
                                                $mins = intval(substr($data,strpos($data, " ")));
                                                $this->uptimeInfo[$this->serverCount]["cm_downtime"] = ($hours*60)+$mins;
						if(!$this->average)
	                                                $this->totalCMDowntime +=($hours*60)+$mins;
                                        }
                                        else
                                        {
                                                $this->uptimeInfo[$this->serverCount]["cm_downtime"] = intval($data);
						if(!$this->average)
	                                                $this->totalCMDowntime += intval($data);
                                        }
					break;
				case "HYPERSPIN:CURMONOUTAGE":
					$this->uptimeInfo[$this->serverCount]["cm_outage"] = $data;
					if(!$this->average)
						$this->totalCMOutages += $data;
					break;
				case "HYPERSPIN:PREMONUPTIME":
					$this->uptimeInfo[$this->serverCount]["pm_uptime"] = floatval($data);
					if(!$this->average)
						$this->totalPMUptime += floatval($data);
					break;
				case "HYPERSPIN:PREMONDOWNTIME":
					if(strpos($data," ") > -1)
					{	
						$hours = intval($data);
						$mins = intval(substr($data,strpos($data, " ")));
						$this->uptimeInfo[$this->serverCount]["pm_downtime"] = ($hours*60)+$mins;
						if(!$this->average)
							$this->totalPMDowntime +=($hours*60)+$mins;
					}
					else
					{
						$this->uptimeInfo[$this->serverCount]["pm_downtime"] = intval($data);
						if(!$this->average)
							$this->totalPMDowntime += intval($data);
					}
					break;
				case "HYPERSPIN:PREMONOUTAGE":
					$this->uptimeInfo[$this->serverCount]["pm_outage"] = $data;
					if(!$this->average)
						$this->totalPMOutages += $data;
					break;
				case "HYPERSPIN:TOTALUPTIME":
					$this->uptimeInfo[$this->serverCount]["tot_uptime"] = floatval($data);
					if(!$this->average)
						$this->totalUptime += floatval($data);
					break;
				case "HYPERSPIN:TOTALDOWNTIME":
					if(strpos($data," ") > -1)
                                        {
                                                $hours = intval($data);
                                                $mins = intval(substr($data,strpos($data, " ")));
                                                $this->uptimeInfo[$this->serverCount]["tot_downtime"] = ($hours*60)+$mins;
						if(!$this->average)
	                                                $this->totalDowntime +=($hours*60)+$mins;
                                        }
                                        else
                                        {
                                                $this->uptimeInfo[$this->serverCount]["tot_downtime"] = intval($data);
						if(!$this->average)
	                                                $this->totalDowntime += intval($data);
                                        }
					break;
				case "HYPERSPIN:TOTALOUTAGE":
					$this->uptimeInfo[$this->serverCount]["tot_outage"] = $data;
					if(!$this->average)
						$this->totalOutages += $data;
					break;
				case "HYPERSPIN:MONITOREDSINCE":
					if(!$this->average)
					{
						$this->uptimeInfo[$this->serverCount]["monitored_since"] = $data;
						$date = split(" ",$data);
						$currDate = mktime(0,0,0,$this->months[$date[0]],$date[1],$date[2]);
						if($currDate < $this->oldestDate || $this->oldestDate ==0)
							$this->oldestDate = $currDate;
					}
					break;
				case "HYPERSPIN:NOTES":
					$this->uptimeInfo[$this->serverCount]["notes"] = $data;
					break;
			}
		}
		
	}

}	
?>
