<?php
/************************************************************
*			Hyperspin RSS Parser version 1.1	*
*								*
*		    		 Code by Adam Neal		*
*					adam@amnwebtech.co.uk	*
*				Feedback and comments welcome	*
*								*
*	You may freely use and distribute the Source Code,	* 
*	with or without modification, but this Source Code is 	*
*	provided to you "AS IS" EXCLUSIVE OF ANY WARRANTY, 	*
*	INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OF 	*
*	MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE, OR *
*	ANY OTHER WARRANTY, WHETHER EXPRESS OR IMPLIED. IN NO 	*
*	EVENT WILL AMN Webtech HAVE ANY LIABILITY FOR ANY LOST 	*
*	PROFITS, LOSS OF DATA OR COSTS OF PROCUREMENT OF 	*
*	SUBSTITUTE GOODS OR SERVICES, OR FOR ANY SPECIAL, 	*
*	INDIRECT, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THIS 	*
*	AGREEMENT, INCLUDING, WITHOUT LIMITATION, THOSE 	*
*	RESULTING FROM THE USE OF THE SOURCE CODE, OR THE 	*
*	FAILURE OF THE SOURCE CODE TO PERFORM, OR FOR ANY OTHER *
*	REASON.							*
*								*
************************************************************/

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head>
		<title>Hyperspin RSS display</title>
		<link href="report.css" rel="stylesheet" type="text/css">
		<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-1">
	</head>
	<body>
<?php

//set timezone for the month calculations (not needed if using server timezone)
putenv("TZ=GMT");
//include the RSS parser
require("includes/hyperspinRSSParser.class.php");

//create a new instance here you can pass the URL e.g. $rss_parser = new hyperspingRSSParser("http://YOURURL")
//passing through the URL. If no URL is passed then the hyperspin Testdrive URL is presumed 
//unless $rss_parser->setURL(URL) is called before parse(). 
//To use a local file create the instance using the following syntax: 
//$rss_parser = new hyperspingRSSParser("/path/to/rss.xml",true)
//or create an instance then $rss_parser->setURL(LOCALPATH) and then set $rss_parser->local = true
//The Testdrive report does not provide a full
//data set so you may notice some missing blocks and PHP notices in your error log. To stop these simply remove 
//the missing statistics from the display section starting on line 626262626262ser = new hyperspinRSSParser();
$rss_parser->parse();

//get the current and previous months as a short textual representation for the table headers
//see the php manual for other options http://uk2.php.net/manual/en/function.date.php
$currMonth = date('M');
$prevMonth = date('M', mktime(0, 0, 0, date("m")-1, date("d"),  date("Y")));

//display the resulst, remove any fields you aren't interested in or aren't available
?>
	<table>
		<tr class="tableHead">
			<td>Name</td>
			<td>Status</td>
			<td>Last Update</td>
			<td>Next Update</td>
			<td>Update Interval</td>
			<td><?=$currMonth;?> Uptime</td>
			<td><?=$currMonth;?> Downtime</td>
			<td><?=$currMonth;?> Outages</td>
			<td><?=$prevMonth;?> Uptime</td>
			<td><?=$prevMonth;?> Downtime</td>
			<td><?=$prevMonth;?> Outages</td>
			<td>Total Uptime</td>
			<td>Total Downtime</td>
			<td>Total Outages</td>
			<td>Monitored Since</td>
			<td>Notes</td>
		</tr>
<?
	foreach($rss_parser->uptimeInfo as $row)
	{
?>
		<tr>
			<td><?=$row['name'];?></td>
			<td class="<?=$row['status'];?>"><?=$row['status'];?></td>
			<td><?=$row['last_update'];?></td>
			<td><?=$row['next_update'];?></td>
			<td><?=$row['update_interval'];?> </td>
			<td><?=$row['cm_uptime'];?>%</td>
			<td><?=$row['cm_downtime'];?> mins</td>
			<td><?=$row['cm_outage'];?></td>
			<td><?=$row['pm_uptime'];?>%</td>
			<td><?=$row['pm_downtime'];?> mins</td>
			<td><?=$row['pm_outage'];?></td>
			<td><?=$row['tot_uptime'];?>%</td>
			<td><?=$row['tot_downtime'];?> mins</td>
			<td><?=$row['tot_outage'];?></td>
			<td><?=$row['monitored_since'];?></td>
			<td><?=$row['notes'];?></td>
		</tr>
<?
	}
?>
</table>
<H2>Totals across all servers</H2>
<table>
<Tr class="tableHead">
	<td>Total <?=$currMonth;?> Outages</td>
	<td>Total <?=$prevMonth;?> Outages</td>
	<td>Outages since <?=$rss_parser->oldestDate;?></td>
	<td>Total <?=$currMonth;?> Downtime</td>
	<td>Total <?=$prevMonth;?> Downtime</td>
	<td>Downtime since <?=$rss_parser->oldestDate;?></td>
</Tr>
<tr>
	<td><?=$rss_parser->totalCMOutages;?></td>
	<td><?=$rss_parser->totalPMOutages;?></td>
	<td><?=$rss_parser->totalOutages;?></td>
	<td><?=$rss_parser->totalCMDowntime;?> mins</td>
	<td><?=$rss_parser->totalPMDowntime;?> mins</td>
	<td><?=$rss_parser->totalDowntime;?> mins</td>
	</tr>
</table>
<h2>Averages across all servers</h2>
<table>
<tr class="tableHead">
	<td>Avg. Srvr. Uptime - <?=$currMonth;?></td>
	<td>Avg. Srvr. Uptime - <?=$prevMonth;?></td>
	<td>Avg. Srvr. Uptime - Total</td>
</tr>
<tr>
	<td><?=$rss_parser->averageSrvrCMUptime;?>%</td>
	<td><?=$rss_parser->averageSrvrPMUptime;?>%</td>
	<td><?=$rss_parser->averageSrvrUptime;?>%</td>
</tr>
</table>

<table>
<tr class="tableHead">
	<td>Avg. Srvr. Downtime - <?=$currMonth;?></td>
	<td>Avg. Srvr. Downtime - <?=$prevMonth;?></td>
	<td>Avg. Srvr. Downtime - Total</td>
</tr>
<tr>
	<td><?=$rss_parser->averageSrvrCMDowntime;?> mins</td>
	<td><?=$rss_parser->averageSrvrPMDowntime;?> mins</td>
	<td><?=$rss_parser->averageSrvrDowntime;?> mins</td>
</tr>
</table>

<table>
<tr class="tableHead">
	<td>Avg. Srvr. Outages - <?=$currMonth;?></td>
	<td>Avg. Srvr. Outages - <?=$prevMonth;?></td>
	<td>Avg. Srvr. Outages - Total</td>
</tr>
<tr>
	<td><?=$rss_parser->averageSrvrCMOutages;?></td>
	<td><?=$rss_parser->averageSrvrPMOutages;?></td>
	<td><?=$rss_parser->averageSrvrOutages;?></td>
</tr>
</table>

</body>
</html>
